/*****************************/
/* kChat v1.9		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.net.*;
import java.io.*;

public class kChatServer 
{

    static kChatPing ping = new kChatPing();
    static int nrPortu = 1979; 
/*************************************************************************************/
	public static void main(String args[]) throws IOException
	{
		ServerSocket serverS = null;
		boolean listening = true;
		
		if ((args.length>0) && (!args[0].equals("")))
		    configFileParse(args[0]); 
		    else 
		    configFileParse("./kChat.conf"); 
		    
		
		try 
{
		    serverS = new ServerSocket(nrPortu);
		    System.out.println("kChat Server Listen at port " + nrPortu);
		}
 catch (IOException e) 
{
		    System.out.println("Listen at " + nrPortu + " impossible, i don't know why ! " + e);
		    System.exit(1);
		}

		ping.start();

		while (listening)
		    new kChatServerThread(serverS.accept()).start();
		    
//		ping.stop();
		ping=null;
		serverS.close();
	}

/*************************************************************************************/
	private static void configFileParse(String filename) {
	    try {
	    FileReader fr = new FileReader(filename);
	    BufferedReader frb = new BufferedReader(fr);
	    
	    String line = new String("");
	    while (line!=null) {
		line = frb.readLine();
		if ((line!=null)&&(!line.startsWith("#"))&&(!line.equals(""))) {
		    String command = line.substring(0,line.indexOf("=",0));
		    String value   = line.substring(line.indexOf("=",0)+1);
		    if (command.equals("log-channel-file")) kChatSystem.logfile=value;
		    if (command.equals("log-channel")) kChatSystem.log=value;
		    if (command.equals("reserved-nicks-list-file")) kChatSystem.rnicksFilename=value;
		    if (command.equals("moderator-passwords-file")) kChatSystem.passwdfile=value;
		    if (command.equals("ping-timeout")) ping.timeout=new Integer(value).parseInt(value);
		    if (command.equals("logout-file")) kChatSystem.logoutFilename = value;
		    if (command.equals("log-level")) kChatSystem.logLevel = new Integer(value).parseInt(value);
		    if (command.equals("port")) nrPortu=new Integer(value).parseInt(value);
		    // LANG TXT
		    if (command.equals("langfile")) {
			    try {
    			    FileReader frlang = new FileReader(value);
    			    BufferedReader frblang = new BufferedReader(frlang);
			    String linelang = new String();
		    	    while (linelang!=null) {
				linelang = frblang.readLine();
		    		if ((linelang!=null)&&(!linelang.startsWith("#"))&&(!linelang.equals(""))) {
		    		    String txttmp = linelang.substring(0,linelang.indexOf("=",0));
				    String valtmp = linelang.substring(linelang.indexOf("=",0)+1);
				    if (txttmp.equals("WELCOME")) kChatSystem.TXT[0] = valtmp;
				    if (txttmp.equals("END")) kChatSystem.TXT[1] = valtmp;
				    if (txttmp.equals("JOIN")) kChatSystem.TXT[2] = valtmp;
				    if (txttmp.equals("MODERINFO")) kChatSystem.TXT[3] = valtmp;
				    if (txttmp.equals("NOMODERINFO")) kChatSystem.TXT[4] = valtmp;
				    if (txttmp.equals("LOGOUT")) kChatSystem.TXT[5] = valtmp;
				    if (txttmp.equals("PRIVBUTTON")) kChatSystem.TXT[6] = valtmp;
				    if (txttmp.equals("MODERBUTTON")) kChatSystem.TXT[7] = valtmp;
				    if (txttmp.equals("LOGOUTBUTTON")) kChatSystem.TXT[8] = valtmp;
				    if (txttmp.equals("CLOSEBUTTON")) kChatSystem.TXT[9] = valtmp;
				    if (txttmp.equals("MODERTITLE")) kChatSystem.TXT[10] = valtmp;
				    if (txttmp.equals("LOGINBUSY")) kChatSystem.TXT[11] = valtmp;
				    if (txttmp.equals("PRIVTITLE")) kChatSystem.TXT[12] = valtmp;
				    if (txttmp.equals("PASSTITLE")) kChatSystem.TXT[13] = valtmp;
				    if (txttmp.equals("YOUMODERATOR")) kChatSystem.TXT[14] = valtmp;
				    if (txttmp.equals("KICKED")) kChatSystem.TXT[15] = valtmp;
				    if (txttmp.equals("KICKBUTTON")) kChatSystem.TXT[16] = valtmp;
				    if (txttmp.equals("TOPICBUTTON")) kChatSystem.TXT[17] = valtmp;
				    }
				}
			    } 
			    catch (IOException e) { System.out.println("Check langfile option !!!"); }
			}
		    }
		}
	    } catch (IOException e) { e.printStackTrace(); }
	}

		
}
